import { defineNuxtModule, addVitePlugin } from '@nuxt/kit';
import ElementPlusVite from 'unplugin-element-plus/vite';
import ViteComponents from 'unplugin-vue-components/vite';
import { ElementPlusResolver } from 'unplugin-vue-components/resolvers';

const name = "nuxt-element-plus-module";
const version = "0.1.0";

const module = defineNuxtModule({
  meta: {
    name,
    version,
    configKey: "element",
    compatibility: {
      nuxt: "3"
    }
  },
  defaults: {
    autoImport: true,
    unpluginOptions: {}
  },
  setup(options, nuxt) {
    nuxt.options.build.transpile.push("element-plus/es");
    addVitePlugin(ElementPlusVite(options.unpluginOptions));
    if (options.autoImport) {
      addVitePlugin(ViteComponents({
        resolvers: [ElementPlusResolver()]
      }));
    }
  }
});

export { module as default };
